package com.fufan.mtsaas.modules.sysmgr.tsysparam.controller;

import com.alibaba.fastjson.JSONObject;
import com.fufan.mtsaas.modules.common.bo.request.DataRequest;
import com.fufan.mtsaas.modules.common.bo.request.DataRequestT;
import com.fufan.mtsaas.modules.common.bo.request.DeleteRequest;
import com.fufan.mtsaas.modules.common.bo.request.ResultPack;
import com.fufan.mtsaas.modules.common.bo.response.RequestPojo;
import com.fufan.mtsaas.modules.common.bo.response.Result;
import com.fufan.mtsaas.modules.sysmgr.tsysparam.bo.request.SysParamQueryRequest;
import com.fufan.mtsaas.modules.sysmgr.tsysparam.bo.request.SysParamSaveRequest;
import com.fufan.mtsaas.modules.sysmgr.tsysparam.bo.response.FlowStatusResponse;
import com.fufan.mtsaas.modules.sysmgr.tsysparam.bo.response.SysParamResponse;
import com.fufan.mtsaas.modules.sysmgr.tsysparam.model.TSysParam;
import com.fufan.mtsaas.modules.sysmgr.tsysparam.service.TSysParamSvc;
import com.fufan.mtsaas.util.JSonUtil;
import com.fufan.mtsaas.util.ParamUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpSession;
import javax.validation.Valid;
import java.util.List;

/**
 * <p>
 *
 * </p>
 *
 * @author Liby
 * @since 2025-03-01
 */
@Slf4j
@Api(tags = "MTSaas：系统管理-系统参数模块", description = "TSysParam对象接口")
@RestController
@RequestMapping("/SYS/SysParam")
public class TSysParamCtrl {
    @Autowired
    private TSysParamSvc targetService;

    /**
     * 分页查询
     */
    @ApiOperation(value = "分页查询所有，根据需要传入分页参数：pageSize每页数量(默认为10)，currentPage当前页数(默认为1)", httpMethod = "POST", produces = "application/json")
    @PostMapping(value = "/doQueryPage")
    public Result<SysParamResponse> doQueryPage(@RequestBody @ApiIgnore DataRequest dataRequest, SysParamQueryRequest request) {
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();

        JSONObject mapdata = dataRequest.getData().getParam();
        SysParamQueryRequest map = JSonUtil.toBean(mapdata.toJSONString(), SysParamQueryRequest.class);

        return resultPack.doResultPack(targetService.doQueryPage(map), requestPojo.getIntfId(), requestPojo.getAppKey());
    }


    /**
     * 分页查询
     */
    @ApiOperation(value = "查询流程状态，根据需要传入分页参数：pageSize每页数量(默认为10)，currentPage当前页数(默认为1)", httpMethod = "POST", produces = "application/json")
    @PostMapping(value = "/doQueryFlowStatus")
    public Result<FlowStatusResponse> doQueryFlowStatus(@RequestBody @ApiIgnore DataRequest dataRequest, SysParamQueryRequest request) {
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();

        JSONObject mapdata = dataRequest.getData().getParam();
        SysParamQueryRequest map = JSonUtil.toBean(mapdata.toJSONString(), SysParamQueryRequest.class);

        return resultPack.doResultPack(targetService.doQueryFlowStatus(map), requestPojo.getIntfId(), requestPojo.getAppKey());
    }

    /**
     * 新增
     */
    @ApiOperation(value = "新增", httpMethod = "POST", produces = "application/json")
    @RequestMapping(value = "/doSave", method = RequestMethod.POST)
    public Result<TSysParam> doSaveMap(@RequestBody @ApiIgnore @Valid DataRequestT<SysParamSaveRequest> dataRequest, SysParamSaveRequest request, @ApiIgnore HttpSession session) {
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();

        return resultPack.doResultPack(targetService.doSave(dataRequest.getData().getParam(), requestPojo), requestPojo.getIntfId(), requestPojo.getAppKey());
    }

    /**
     * 修改
     */
    @ApiOperation(value = "修改", httpMethod = "PUT", produces = "application/json")
    @RequestMapping(value = "/doUpdate", method = RequestMethod.PUT)
    public Result<TSysParam> doUpdateMap(@RequestBody @ApiIgnore @Valid DataRequestT<SysParamSaveRequest> dataRequest, SysParamSaveRequest request, @ApiIgnore HttpSession session) {
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();

        return resultPack.doResultPack(targetService.doUpdate(dataRequest.getData().getParam(), requestPojo), requestPojo.getIntfId(), requestPojo.getAppKey());
    }

    /**
     * 删除数据
     */
    @ApiOperation(value = "删除数据", httpMethod = "DELETE", produces = "application/json")
    @RequestMapping(value = "/doDelete", method = RequestMethod.DELETE)
    public Result doDelete(@RequestBody @ApiIgnore DataRequest dataRequest, DeleteRequest request) {
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        DeleteRequest map = JSonUtil.toBean(mapdata.toJSONString(), DeleteRequest.class);

        return resultPack.doResultPack(targetService.doDelete(map, requestPojo), requestPojo.getIntfId(), requestPojo.getAppKey());
    }


}
